Given an array arr[] of size N representing the available denominations and an integer X. The task is to find any combination of the minimum number of coins of the available denominations such that the sum of the coins is X. If the given sum cannot be obtained by the available denominations, print -1.
Examples:
Input: X = 21, arr[] = {2, 3, 4, 5}
Output: 2 4 5 5 5
Explanation:
One possible solution is {2, 4, 5, 5, 5} where 2 + 4 + 5 + 5 + 5 = 21.
Another possible solution is {3, 3, 5, 5, 5}.Input: X = 1, arr[] = {2, 4, 6, 9}
Output: -1
Explanation:
All coins are greater than 1. Hence, no solution exist.
Naive Approach: The simplest approach is to try all possible combinations of given denominations such that in each combination, the sum of coins is equal to X. From these combinations, choose the one having the minimum number of coins and print it. If the sum any combinations is not equal to X, print -1.
Time Complexity: O(XN)
Auxiliary Space: O(N)
Efficient Approach: The above approach can be optimized using Dynamic Programming to find the minimum number of coins. While finding the minimum number of coins, backtracking can be used to track the coins needed to make their sum equals to X. Follow the below steps to solve the problem:
- Initialize an auxiliary array dp[], where dp[i] will store the minimum number of coins needed to make sum equals to i.
- Find the minimum number of coins needed to make their sum equals to X using the approach discussed in this article.
- After finding the minimum number of coins use the Backtracking Technique to track down the coins used, to make the sum equals to X.
- In backtracking, traverse the array and choose a coin which is smaller than the current sum such that dp[current_sum] equals to dp[current_sum – chosen_coin]+1. Store the chosen coin in an array.
- After completing the above step, backtrack again by passing the current sum as (current sum – chosen coin value).
- After finding the solution, print the array of chosen coins.
Below is the implementation of the above approach:
C++
// C++ program for the above approach #include <bits/stdc++.h> using namespace std; #define MAX 100000 // dp array to memoize the results int dp[MAX + 1]; // List to store the result list< int > denomination; // Function to find the minimum number of // coins to make the sum equals to X int countMinCoins( int n, int C[], int m) { // Base case if (n == 0) { dp[0] = 0; return 0; } // If previously computed // subproblem occurred if (dp[n] != -1) return dp[n]; // Initialize result int ret = INT_MAX; // Try every coin that has smaller // value than n for ( int i = 0; i < m; i++) { if (C[i] <= n) { int x = countMinCoins(n - C[i], C, m); // Check for INT_MAX to avoid // overflow and see if result // can be minimized if (x != INT_MAX) ret = min(ret, 1 + x); } } // Memoizing value of current state dp[n] = ret; return ret; } // Function to find the possible // combination of coins to make // the sum equal to X void findSolution( int n, int C[], int m) { // Base Case if (n == 0) { // Print Solutions for ( auto it : denomination) { cout << it << ' ' ; } return ; } for ( int i = 0; i < m; i++) { // Try every coin that has // value smaller than n if (n - C[i] >= 0 and dp[n - C[i]] + 1 == dp[n]) { // Add current denominations denomination.push_back(C[i]); // Backtrack findSolution(n - C[i], C, m); break ; } } } // Function to find the minimum // combinations of coins for value X void countMinCoinsUtil( int X, int C[], int N) { // Initialize dp with -1 memset (dp, -1, sizeof (dp)); // Min coins int isPossible = countMinCoins(X, C, N); // If no solution exists if (isPossible == INT_MAX) { cout << "-1" ; } // Backtrack to find the solution else { findSolution(X, C, N); } } // Driver code int main() { int X = 21; // Set of possible denominations int arr[] = { 2, 3, 4, 5 }; int N = sizeof (arr) / sizeof (arr[0]); // Function Call countMinCoinsUtil(X, arr, N); return 0; } |
Java
// Java program for // the above approach import java.util.*; class GFG{ static final int MAX = 100000 ; // dp array to memoize the results static int []dp = new int [MAX + 1 ]; // List to store the result static List<Integer> denomination = new LinkedList<Integer>(); // Function to find the minimum // number of coins to make the // sum equals to X static int countMinCoins( int n, int C[], int m) { // Base case if (n == 0 ) { dp[ 0 ] = 0 ; return 0 ; } // If previously computed // subproblem occurred if (dp[n] != - 1 ) return dp[n]; // Initialize result int ret = Integer.MAX_VALUE; // Try every coin that has smaller // value than n for ( int i = 0 ; i < m; i++) { if (C[i] <= n) { int x = countMinCoins(n - C[i], C, m); // Check for Integer.MAX_VALUE to avoid // overflow and see if result // can be minimized if (x != Integer.MAX_VALUE) ret = Math.min(ret, 1 + x); } } // Memoizing value of current state dp[n] = ret; return ret; } // Function to find the possible // combination of coins to make // the sum equal to X static void findSolution( int n, int C[], int m) { // Base Case if (n == 0 ) { // Print Solutions for ( int it : denomination) { System.out.print(it + " " ); } return ; } for ( int i = 0 ; i < m; i++) { // Try every coin that has // value smaller than n if (n - C[i] >= 0 && dp[n - C[i]] + 1 == dp[n]) { // Add current denominations denomination.add(C[i]); // Backtrack findSolution(n - C[i], C, m); break ; } } } // Function to find the minimum // combinations of coins for value X static void countMinCoinsUtil( int X, int C[], int N) { // Initialize dp with -1 for ( int i = 0 ; i < dp.length; i++) dp[i] = - 1 ; // Min coins int isPossible = countMinCoins(X, C, N); // If no solution exists if (isPossible == Integer.MAX_VALUE) { System.out.print( "-1" ); } // Backtrack to find the solution else { findSolution(X, C, N); } } // Driver code public static void main(String[] args) { int X = 21 ; // Set of possible denominations int arr[] = { 2 , 3 , 4 , 5 }; int N = arr.length; // Function Call countMinCoinsUtil(X, arr, N); } } // This code is contributed by Rajput-Ji |
Python3
# Python3 program for the above approach import sys MAX = 100000 # dp array to memoize the results dp = [ - 1 ] * ( MAX + 1 ) # List to store the result denomination = [] # Function to find the minimum number of # coins to make the sum equals to X def countMinCoins(n, C, m): # Base case if (n = = 0 ): dp[ 0 ] = 0 return 0 # If previously computed # subproblem occurred if (dp[n] ! = - 1 ): return dp[n] # Initialize result ret = sys.maxsize # Try every coin that has smaller # value than n for i in range (m): if (C[i] < = n): x = countMinCoins(n - C[i], C, m) # Check for INT_MAX to avoid # overflow and see if result # can be minimized if (x ! = sys.maxsize): ret = min (ret, 1 + x) # Memoizing value of current state dp[n] = ret return ret # Function to find the possible # combination of coins to make # the sum equal to X def findSolution(n, C, m): # Base Case if (n = = 0 ): # Print Solutions for it in denomination: print (it, end = " " ) return for i in range (m): # Try every coin that has # value smaller than n if (n - C[i] > = 0 and dp[n - C[i]] + 1 = = dp[n]): # Add current denominations denomination.append(C[i]) # Backtrack findSolution(n - C[i], C, m) break # Function to find the minimum # combinations of coins for value X def countMinCoinsUtil(X, C,N): # Initialize dp with -1 # memset(dp, -1, sizeof(dp)) # Min coins isPossible = countMinCoins(X, C,N) # If no solution exists if (isPossible = = sys.maxsize): print ( "-1" ) # Backtrack to find the solution else : findSolution(X, C, N) # Driver code if __name__ = = '__main__' : X = 21 # Set of possible denominations arr = [ 2 , 3 , 4 , 5 ] N = len (arr) # Function call countMinCoinsUtil(X, arr, N) # This code is contributed by mohit kumar 29 |
C#
// C# program for // the above approach using System; using System.Collections.Generic; class GFG{ static readonly int MAX = 100000; // dp array to memoize the results static int []dp = new int [MAX + 1]; // List to store the result static List< int > denomination = new List< int >(); // Function to find the minimum // number of coins to make the // sum equals to X static int countMinCoins( int n, int []C, int m) { // Base case if (n == 0) { dp[0] = 0; return 0; } // If previously computed // subproblem occurred if (dp[n] != -1) return dp[n]; // Initialize result int ret = int .MaxValue; // Try every coin that has smaller // value than n for ( int i = 0; i < m; i++) { if (C[i] <= n) { int x = countMinCoins(n - C[i], C, m); // Check for int.MaxValue to avoid // overflow and see if result // can be minimized if (x != int .MaxValue) ret = Math.Min(ret, 1 + x); } } // Memoizing value of current state dp[n] = ret; return ret; } // Function to find the possible // combination of coins to make // the sum equal to X static void findSolution( int n, int []C, int m) { // Base Case if (n == 0) { // Print Solutions foreach ( int it in denomination) { Console.Write(it + " " ); } return ; } for ( int i = 0; i < m; i++) { // Try every coin that has // value smaller than n if (n - C[i] >= 0 && dp[n - C[i]] + 1 == dp[n]) { // Add current denominations denomination.Add(C[i]); // Backtrack findSolution(n - C[i], C, m); break ; } } } // Function to find the minimum // combinations of coins for value X static void countMinCoinsUtil( int X, int []C, int N) { // Initialize dp with -1 for ( int i = 0; i < dp.Length; i++) dp[i] = -1; // Min coins int isPossible = countMinCoins(X, C, N); // If no solution exists if (isPossible == int .MaxValue) { Console.Write( "-1" ); } // Backtrack to find the solution else { findSolution(X, C, N); } } // Driver code public static void Main(String[] args) { int X = 21; // Set of possible denominations int []arr = {2, 3, 4, 5}; int N = arr.Length; // Function Call countMinCoinsUtil(X, arr, N); } } // This code is contributed by shikhasingrajput |
Javascript
<script> // Javascript program for the above approach var MAX = 100000; // dp array to memoize the results var dp = Array(MAX+1); // List to store the result var denomination = []; // Function to find the minimum number of // coins to make the sum equals to X function countMinCoins(n, C, m) { // Base case if (n == 0) { dp[0] = 0; return 0; } // If previously computed // subproblem occurred if (dp[n] != -1) return dp[n]; // Initialize result var ret = 1000000000; // Try every coin that has smaller // value than n for ( var i = 0; i < m; i++) { if (C[i] <= n) { var x = countMinCoins(n - C[i], C, m); // Check for INT_MAX to avoid // overflow and see if result // can be minimized if (x != 1000000000) ret = Math.min(ret, 1 + x); } } // Memoizing value of current state dp[n] = ret; return ret; } // Function to find the possible // combination of coins to make // the sum equal to X function findSolution(n, C, m) { // Base Case if (n == 0) { denomination.forEach(it => { document.write( it + ' ' ); }); return ; } for ( var i = 0; i < m; i++) { // Try every coin that has // value smaller than n if (n - C[i] >= 0 && dp[n - C[i]] + 1 == dp[n]) { // Add current denominations denomination.push(C[i]); // Backtrack findSolution(n - C[i], C, m); break ; } } } // Function to find the minimum // combinations of coins for value X function countMinCoinsUtil(X, C, N) { // Initialize dp with -1 dp = Array(MAX+1).fill(-1); // Min coins var isPossible = countMinCoins(X, C, N); // If no solution exists if (isPossible == 1000000000) { document.write( "-1" ); } // Backtrack to find the solution else { findSolution(X, C, N); } } // Driver code var X = 21; // Set of possible denominations var arr = [2, 3, 4, 5]; var N = arr.length; // Function Call countMinCoinsUtil(X, arr, N); </script> |
2 4 5 5 5
Time Complexity: O(N*X), where N is the length of the given array and X is the given integer.
Auxiliary Space: O(N)
Efficient approach : Using DP Tabulation method ( Iterative approach )
The approach to solve this problem is same but DP tabulation(bottom-up) method is better then Dp + memoization(top-down) because memoization method needs extra stack space of recursion calls.
Steps to solve this problem :
- Create a array DP to store the solution of the subproblems and initialize it with INT_MAX.
- Initialize the array DP with base case i.e. dp[0] = 0 .
- Now Iterate over subproblems to get the value of current problem form previous computation of subproblems stored in DP
- Return the final solution stored in dp[X].
Implementation :
C++
// C++ program for above approach #include <bits/stdc++.h> using namespace std; #define MAX 100000 // Function to find the minimum number of // coins to make the sum equals to X int countMinCoins( int X, int C[], int N) { // dp array to store the minimum number of coins for each value from 0 to X int dp[X + 1]; // Initialize dp array dp[0] = 0; for ( int i = 1; i <= X; i++) { dp[i] = INT_MAX; } // Loop through all values from 1 to X and compute the minimum number of coins for ( int i = 1; i <= X; i++) { for ( int j = 0; j < N; j++) { if (C[j] <= i && dp[i - C[j]] != INT_MAX) { dp[i] = min(dp[i], 1 + dp[i - C[j]]); } } } // If no solution exists if (dp[X] == INT_MAX) { cout << "-1" ; return -1; } // Print the solution int i = X; while (i > 0) { for ( int j = 0; j < N; j++) { if (i >= C[j] && dp[i - C[j]] == dp[i] - 1) { cout << C[j] << " " ; i -= C[j]; break ; } } } return dp[X]; } // Driver code int main() { int X = 21; // Set of possible denominations int arr[] = { 2, 3, 4, 5 }; int N = sizeof (arr) / sizeof (arr[0]); // Function Call countMinCoins(X, arr, N); return 0; } // this code is contributed by bhardwajji |
Java
import java.util.*; public class Main { // Function to find the minimum number of coins to make the sum equals to X public static int countMinCoins( int X, int [] C, int N) { // dp array to store the minimum number of coins for each value from 0 to X int [] dp = new int [X + 1 ]; // Initialize dp array dp[ 0 ] = 0 ; for ( int i = 1 ; i <= X; i++) { dp[i] = Integer.MAX_VALUE; } // Loop through all values from 1 to X and compute // the minimum number of coins for ( int i = 1 ; i <= X; i++) { for ( int j = 0 ; j < N; j++) { if (C[j] <= i && dp[i - C[j]] != Integer.MAX_VALUE) { dp[i] = Math.min(dp[i], 1 + dp[i - C[j]]); } } } // If no solution exists if (dp[X] == Integer.MAX_VALUE) { System.out.println( "-1" ); return - 1 ; } // Print the solution int i = X; while (i > 0 ) { for ( int j = 0 ; j < N; j++) { if (i >= C[j] && dp[i - C[j]] == dp[i] - 1 ) { System.out.print(C[j] + " " ); i -= C[j]; break ; } } } System.out.println(); return dp[X]; } // Driver code public static void main(String[] args) { int X = 21 ; // Set of possible denominations int [] arr = { 2 , 3 , 4 , 5 }; int N = arr.length; // Function Call countMinCoins(X, arr, N); } } |
Python3
import sys # Function to find the minimum number of coins to make the sum equals to X def countMinCoins(X, C, N): # dp array to store the minimum number of coins for each value from 0 to X dp = [sys.maxsize] * (X + 1 ) # Initialize dp array dp[ 0 ] = 0 # Loop through all values from 1 to X and compute the minimum number of coins for i in range ( 1 , X + 1 ): for j in range (N): if C[j] < = i and dp[i - C[j]] ! = sys.maxsize: dp[i] = min (dp[i], 1 + dp[i - C[j]]) # If no solution exists if dp[X] = = sys.maxsize: print ( "-1" ) return - 1 # Print the solution i = X while i > 0 : for j in range (N): if i > = C[j] and dp[i - C[j]] = = dp[i] - 1 : print (C[j], end = " " ) i - = C[j] break return dp[X] # Driver code if __name__ = = "__main__" : X = 21 # Set of possible denominations arr = [ 2 , 3 , 4 , 5 ] N = len (arr) # Function Call countMinCoins(X, arr, N) |
C#
using System; class Program { // Function to find the minimum number of coins to make the sum equals to X static int CountMinCoins( int X, int [] C, int N) { // dp array to store the minimum number of coins for each value from 0 to X int [] dp = new int [X + 1]; // Initialize dp array dp[0] = 0; for ( int i = 1; i <= X; i++) { dp[i] = int .MaxValue; } // Loop through all values from 1 to X and compute the minimum number of coins for ( int i = 1; i <= X; i++) { for ( int j = 0; j < N; j++) { if (C[j] <= i && dp[i - C[j]] != int .MaxValue) { dp[i] = Math.Min(dp[i], 1 + dp[i - C[j]]); } } } // If no solution exists if (dp[X] == int .MaxValue) { Console.WriteLine( "-1" ); return -1; } // Print the solution int k = X; while (k > 0) { for ( int j = 0; j < N; j++) { if (k >= C[j] && dp[k - C[j]] == dp[k] - 1) { Console.Write(C[j] + " " ); k -= C[j]; break ; } } } return dp[X]; } // Driver code static void Main( string [] args) { int X = 21; // Set of possible denominations int [] arr = { 2, 3, 4, 5 }; int N = arr.Length; // Function Call CountMinCoins(X, arr, N); } } |
Javascript
// javascript code addition // Function to find the minimum number of coins to make the sum equals to X function countMinCoins(X, C, N) { // dp array to store the minimum number of coins for each value from 0 to X const dp = new Array(X + 1).fill(Infinity); // Initialize dp array dp[0] = 0; // Loop through all values from 1 to X and compute the minimum number of coins for (let i = 1; i <= X; i++) { for (let j = 0; j < N; j++) { if (C[j] <= i && dp[i - C[j]] !== Infinity) { dp[i] = Math.min(dp[i], 1 + dp[i - C[j]]); } } } // If no solution exists if (dp[X] === Infinity) { console.log( "-1" ); return -1; } // Print the solution let i = X; const result = []; while (i > 0) { for (let j = 0; j < N; j++) { if (i >= C[j] && dp[i - C[j]] === dp[i] - 1) { result.push(C[j]); i -= C[j]; break ; } } } console.log(result.join( ' ' )); return dp[X]; } // Driver code const X = 21; // Set of possible denominations const arr = [2, 3, 4, 5]; const N = arr.length; // Function Call countMinCoins(X, arr, N); // The code is contributed by Nidhi goel. |
Output
2 4 5 5 5
Time Complexity: O(N*X), where N is the length of the given array and X is the given integer.
Auxiliary Space: O(X)
Ready to dive in? Explore our Free Demo Content and join our DSA course, trusted by over 100,000 neveropen!